  
Ext.onReady(function(){
Ext.state.Manager.setProvider(new Ext.state.CookieProvider());  
//Ext.Component.prototype.stateful = false;

/*
 * Class for saving grid state. Modeled on LayoutStateManager
 */


    
sizes=Ext.getBody().getViewSize();
  // create reusable renderer for ComboBox
Ext.util.Format.comboRenderer = function(combo){
    return function(value){
        var record = combo.findRecord(combo.valueField || combo.displayField, value);
        return record ? record.get(combo.displayField) : combo.valueNotFoundText;
    }
}         
  /**
 * @class Ext.grid.ComboColumn
 * @extends Ext.grid.Column
 * <p>A Column definition class which renders a ComboBox field based on the Column's configured
 * editor. See the {@link Ext.grid.ColumnModel#xtype xtype} config option of {@link Ext.grid.ColumnModel}
 * for more details.</p>
 */
Ext.grid.ComboColumn = Ext.extend(Ext.grid.Column, {
    constructor: function(cfg){
        Ext.grid.ComboColumn.superclass.constructor.call(this, cfg);
        this.renderer = Ext.util.Format.comboRenderer(this.editor.field ? this.editor.field : this.editor);
    }
});

// apply the custom column type to the prototype
Ext.apply(Ext.grid.Column.types, {
    combocolumn: Ext.grid.ComboColumn
});
   
  //mask  
  var myMask = new Ext.LoadMask(Ext.getBody(), {msg:"Please wait..."});
        
  var print= new Ext.Button( {
        text:"Nyomtats",
        iconCls:'printer',
        handler: function(){ 
              var cols="";  
              var order="";
              console.log(gridStudio)  ;
              for (rowIndex = 0; rowIndex < gridStudio.colModel.getColumnCount(); rowIndex++) {
                  selHeader=gridStudio.colModel.getColumnAt(rowIndex); 
                  console.log(selHeader);
                  if(selHeader.hidden===true)
                  {
                      cols=cols+selHeader.dataIndex+".";
                  }else{
                      order=order+selHeader.dataIndex+".";    
                  }
                  
              }
              
            window.open('manage.php?print=1&cols='+cols+'&order='+order+'&sort='+gridStudio.store.sortInfo.field+'&sortdir='+gridStudio.store.sortInfo.direction);
        }
  });   
  var logout= new Ext.Button( {
        text:"Kilps",
        iconCls:'logout',
        handler: function(){ 
            window.location='manage.php?logout=1';
        }
  }); 
var notokFilter = new Ext.form.Checkbox();    
  var filterBtn= new Ext.Button( {
        text:"Szrs",
        iconCls:'find',
        handler: function(){ 
            store.load({params: {'notok':notokFilter.getValue()}});    
        }
  });  

      var store = new Ext.data.Store({
        id: 'SYS_EVENTSCONTACT_Store',
        proxy: new Ext.data.HttpProxy({
                url: 'manage_ajax.php',
                method: 'POST'
            }),
        remoteSort: true,
        reader: new Ext.data.JsonReader({
          root: 'results',
          totalProperty: 'total',
          id: 'id'
        },[
           {name: 'id', type: 'int', mapping: 'id'},
           {name: 'password', type: 'string', mapping: 'password'},
           {name: 'email', type: 'string', mapping: 'email'},
           {name: 'login_id', type: 'string', mapping: 'login_id'},
           {name: 'Title', type: 'string', mapping: 'Title'},
           {name: 'First', type: 'string', mapping: 'First'},
           {name: 'Last', type: 'string', mapping: 'Last'},
           {name: 'Position', type: 'string', mapping: 'Position'},
           {name: 'Address', type: 'string', mapping: 'Address'},
           {name: 'Tel', type: 'string', mapping: 'Tel'},
           {name: 'Fax', type: 'string', mapping: 'Fax'},
           {name: 'Arrival', type: 'string', mapping: 'Arrival'},
           {name: 'Departure', type: 'string', mapping: 'Departure'},
           {name: 'dietary', type: 'string', mapping: 'dietary'},
           {name: 'TopicOther', type: 'string', mapping: 'TopicOther'},
           {name: 'date_last', type: 'string', mapping: 'date_last'},
           {name: 'date_reg', type: 'string', mapping: 'date_reg'},
           {name: 'new_travel', type: 'string', mapping: 'new_travel'},
           {name: 'new_hotel', type: 'string', mapping: 'new_hotel'},
           {name: 'new_hotel_text', type: 'string', mapping: 'new_hotel_text'},
           {name: 'new_pay', type: 'string', mapping: 'new_pay'},
           {name: 'new_welcome', type: 'string', mapping: 'new_welcome'},
           {name: 'new_accompanying', type: 'string', mapping: 'new_accompanying'},
           {name: 'new_payment', type: 'string', mapping: 'new_payment'},
           {name: 'new_eat_text', type: 'string', mapping: 'new_eat_text'},
           {name: 'new_eat_amount', type: 'string', mapping: 'new_eat_amount'},
           {name: 'new_eat_payment', type: 'string', mapping: 'new_eat_payment'},
           {name: 'new_invoice_address', type: 'string', mapping: 'new_invoice_address'},
           {name: 'new_banquet', type: 'string', mapping: 'new_banquet'},
           {name: 'new_tour', type: 'string', mapping: 'new_tour'},
           {name: 'new_eat', type: 'string', mapping: 'new_eat'},
           {name: 'new_eat_text', type: 'string', mapping: 'new_eat_text'},
           {name: 'new_publication', type: 'string', mapping: 'new_publication'},
           {name: 'new_comment1', type: 'string', mapping: 'new_comment1'},
           {name: 'new_comment2', type: 'string', mapping: 'new_comment2'},
           {name: 'new_comment3', type: 'string', mapping: 'new_comment3'},
           {name: 'all_ok', type: 'string', mapping: 'all_ok'}
          ]),
        sortInfo:{field: 'date_reg', direction: "ASC"}
    });    
    // create the Data Store
   
  
    //Override button text
    var editor = new Ext.ux.grid.RowEditor({
        saveText: 'Update'
    });

    //Grid panel config   
    var gridStudio = new Ext.grid.GridPanel({
        store: store,
        loadMask: true,
        viewConfig:{
            
          altRowCls:'xxxx',
          getRowClass: function(record, index, rowParams, ds) {
                // console.log(record);
                 return record.get('all_ok') == 'NEM OK' ? 'yellow' : '';
                   //return 'yellow'

          },   
          trackOver: false          
        },
        stateId: 'gridStudio',
       // stateful: true,        
        renderTo: Ext.getBody(),
        height:sizes.height,
        title: 'Rsztvevk',
        frame:true,
        plugins: [editor],
        // paging bar on the bottom
        tbar:['Problms:',notokFilter,filterBtn],
        bbar: [print,'->',logout],
        /*Ext.create('Ext.PagingToolbar', {
            store: store,
            displayInfo: true,
            displayMsg: 'Displaying topics {0} - {1} of {2}',
            emptyMsg: "No topics to display"
        }),
        */
        columns: [ {
            header: 'Ok?',
            dataIndex: 'all_ok',
            width: 50, 
            sortable: true,
            editor: {
                xtype: 'combo',
                store:  new Ext.data.SimpleStore({
                           fields: ['privileg_value', 'privileg_name'],
                           data: [
                            ["OK", "OK"],
                            ["NEM OK", "NEM OK"]
                            ]                              
                    }),
                displayField: 'privileg_name',
                valueField: 'privileg_value',
                mode: 'local',
                selectOnFocus: true,
                triggerAction: 'all'
                
            }            
           
        },{
            width: 60,
            sortable: true,            
            header: 'id',
            dataIndex: 'id'
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'Password',
            dataIndex: 'password',
            editor: {
                allowBlank: true
            }
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'login_id',
            dataIndex: 'login_id',
            editor: {
                allowBlank: true
            }
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'email',
            dataIndex: 'email',
            editor: {
                allowBlank: true,
                vtype: 'email'                   
            }
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'Title',
            dataIndex: 'Title',
            editor: {
                allowBlank: true
            }
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'First',
            dataIndex: 'First',
            editor: {
                allowBlank: true
            }
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'Last',
            dataIndex: 'Last',
            editor: {
                allowBlank: true
            }
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'Position',
            dataIndex: 'Position',
            editor: {
                allowBlank: true
            }
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'Address',
            dataIndex: 'Address',
            editor: {
                allowBlank: true
            }
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'Tel',
            dataIndex: 'Tel',
            editor: {
                allowBlank: true
            }
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'Fax',
            dataIndex: 'Fax',
            editor: {
                allowBlank: true
            }
        }, 
        {
            width: 60,
            sortable: true,            
            header: 'Arrival',
            dataIndex: 'Arrival',
            editor: {
                allowBlank: true
            }
        }, 
        {
            header: 'Departure',
            sortable: true,            
            dataIndex: 'Departure',
            editor: {
                allowBlank: true
            }
        }, 
        {
            header: 'dietary',
            sortable: true,            
            dataIndex: 'dietary',
            editor: {
                allowBlank: true
            }
        }, 
        {
            header: 'TopicOther',
            sortable: true,            
            dataIndex: 'TopicOther',
            editor: {
                allowBlank: true
            }
        }, 
        {
            header: 'date_last',
            sortable: true,            
            dataIndex: 'date_last',
            width:150
        }, 
        {
            header: 'date_reg',
            sortable: true,            
            dataIndex: 'date_reg'
        }, 
        {
            header: 'Travel',
            sortable: true,            
            dataIndex: 'new_travel',
            editor: {
                xtype: 'combo',
                store:  new Ext.data.SimpleStore({
                           fields: ['privileg_value', 'privileg_name'],
                           data: [
                            ["Own cost", "Own cost"],
                            ["Paid", "Paid"]
                            ]                              
                    }),
                displayField: 'privileg_name',
                valueField: 'privileg_value',
                mode: 'local',
                selectOnFocus: true,
                triggerAction: 'all'
            }                   
        }, 
        {
            header: 'Accommodation',
            dataIndex: 'new_hotel',
            width: 100,             
            editor: {
                xtype: 'combo',
                store:  new Ext.data.SimpleStore({
                           fields: ['privileg_value', 'privileg_name'],
                           data: [
                            ["No", "No"],
                            ["Ok", "Ok"]
                            ]                              
                    }),
                displayField: 'privileg_name',
                valueField: 'privileg_value',
                mode: 'local',
                selectOnFocus: true,
                triggerAction: 'all'
            }
        }, 
        {
            header: 'Accom. notes',
            dataIndex: 'new_hotel_text',
            editor: {
                allowBlank: true
            }
        }, 
        {
            header: 'Registration fee',
            dataIndex: 'new_pay',
            editor: {
                xtype: 'combo',
                store:  new Ext.data.SimpleStore({
                           fields: ['privileg_value', 'privileg_name'],
                           data: [
                            ["Unpaid", "Unpaid"],
                            ["Paid", "Paid"],
                            ["Invited", "Invited"],
                            ["None", "None"]
                            ]                              
                    }),
                displayField: 'privileg_name',
                valueField: 'privileg_value',
                mode: 'local',
                selectOnFocus: true,
                triggerAction: 'all'
            }            

        },
        {
            header: 'Welcome party',
            dataIndex: 'new_welcome',
            editor: {
                xtype: 'textarea'
            }
        },  
        {
            header: 'Banquet',
            dataIndex: 'new_banquet',
            editor: {
                xtype: 'combo',
                store:  new Ext.data.SimpleStore({
                           fields: ['privileg_value', 'privileg_name'],
                           data: [
                            ["Reg. fee incl.", "Reg. fee incl."],
                            ["Own cost", "Own cost"],
                            ["Invited", "Invited"],
                            ["None", "None"]
                            ]                               
                    }),
                displayField: 'privileg_name',
                valueField: 'privileg_value',
                mode: 'local',
                selectOnFocus: true,
                triggerAction: 'all'
            }            
        }, 
        {
            header: 'Social program',
            dataIndex: 'new_tour',
            editor: {
                xtype: 'combo',
                store:  new Ext.data.SimpleStore({
                           fields: ['privileg_value', 'privileg_name'],
                           data: [
                            ["Reg. fee incl.", "Reg. fee incl."],
                            ["Own cost", "Own cost"],
                            ["Invited", "Invited"],
                            ["None", "None"]
                            ]                               
                    }),
                displayField: 'privileg_name',
                valueField: 'privileg_value',
                mode: 'local',
                selectOnFocus: true,
                triggerAction: 'all'
            }            
        },
        {
            header: 'Accompanying person',
            dataIndex: 'new_accompanying',
            editor: {
                xtype: 'textarea'
            } 
        }, 
        {
            header: 'Payment(events)',
            dataIndex: 'new_payment',
            editor: {
                xtype: 'textarea'
            } 
        },  
        {
            header: 'Meals',
            dataIndex: 'new_eat',
            editor: {
                xtype: 'combo',
                store:  new Ext.data.SimpleStore({
                           fields: ['privileg_value', 'privileg_name'],
                           data: [
                            ["No", "No"],
                            ["Yes", "Yes"]
                            ]                               
                    }),
                displayField: 'privileg_name',
                valueField: 'privileg_value',
                mode: 'local',
                selectOnFocus: true,
                triggerAction: 'all'
            }            
        },
        {
            header: 'Meals notes',
            dataIndex: 'new_eat_text',
            editor: {
                allowBlank: true
            }
        }, 
        {
            header: 'Amount (meals)',
            dataIndex: 'new_eat_amount',
            editor: {
                xtype: 'textarea'
            } 
        },        
        {
            header: 'Payment (meals)',
            dataIndex: 'new_eat_payment',
            editor: {
                xtype: 'textarea'
            } 
        },
        {
            header: 'Invoice address',
            dataIndex: 'new_invoice_address',
            editor: {
                xtype: 'textarea'
            } 
        },        
        {
            header: 'Publication',
            dataIndex: 'new_publication',
            editor: {
                xtype: 'combo',
                store:  new Ext.data.SimpleStore({
                           fields: ['privileg_value', 'privileg_name'],
                           data: [
                            ["No", "No"],
                            ["Ok", "Ok"]
                            ]                               
                    }),
                displayField: 'privileg_name',
                valueField: 'privileg_value',
                mode: 'local',
                selectOnFocus: true,
                triggerAction: 'all'
            }             
        }, 
        {
            header: 'Notes',
            dataIndex: 'new_comment1',
            editor: {
                xtype: 'textarea'
            }                    
        }, 
        {
            header: 'Signature',
            dataIndex: 'new_comment2',
            editor: {
                xtype: 'textarea'
            } 
        }]
        
    }); 
    

    store.load(1); 

    editor.on('afteredit', onEdit, this);
    gridStudio.on('cellclick', function(grid, row, columnIndex, e,record){
        var selHeader=grid.colModel.getColumnAt(columnIndex);  
        var selectedCell=selHeader.dataIndex;
        var rec = grid.getStore().getAt(row); // SelectionModel might not give you one single row!

         var val = rec.get(selectedCell);
         var valId = rec.get('id'); 
           
           if(  selectedCell=='new_accompanying' || selectedCell=='new_payment' || 
                selectedCell=='new_eat_amount' || selectedCell=='new_eat_payment' || 
                selectedCell=='new_invoice_address' || selectedCell=='new_comment1' || 
                selectedCell=='new_comment2'|| selectedCell=='new_welcome' ){
               
                var Field1=new Ext.form.Hidden({
                   name:'id',                                                                                             
                   value: ''
                });
               var Field2=new Ext.form.Hidden({
                   name:'field',            
                   value: ''
                });
               var Field3=new Ext.form.TextArea({
                    name:'comment', 
                    allowBlank: true,
                    width:370,
                    height:300
                });   
               Field1.setValue(valId);
               Field2.setValue(selectedCell);
               Field3.setValue(val);

               var FormPanel= new Ext.FormPanel({
                           labelAlign: 'top',
                           labelWidth: 1,
                           width: 400,
                           url:'manage_ajax.php',
                           baseParams:{"method": "addcomment"},
                           border: false,
                           bodyStyle:'padding:5px',
                           border: false,
                           monitorValid:true,
                           defaultType: 'textfield', 
                           items: [ Field1,Field2,Field3],
                           buttons: [{
                                       text: "Ments",
                                       handler: function(){
             
                                         FormPanel.getForm() .submit({

                                                success: function(form, action) {
                                                    store.data.items[row].data[selectedCell]=Field3.getValue();
                                                    gridStudio.getView().refresh(); 
                                                  CommentWindow.close(); 
                                                }
                                         });
             
                                       },
                                       formBind: true
                                     },{
                                       text: "Mgse",
                                       handler: function(){
                                         
                                         CommentWindow.close();
                                       }
                                     }]
                      });   
                                  
                    
               var CommentWindow= new Ext.Window({
                title: 'Megjegzs rsa',
                width: 400,
                height: 400,
                modal:true,
                layout: 'fit',
                items:[FormPanel] 
   
            });       
            CommentWindow.show();               
           } 
           
    });
    


    
    function onEdit(e) {
        // execute an XHR to send/commit data to the server, in callback do (if successful):
        myMask.show();
        Ext.Ajax.request({
              url   : 'manage_ajax.php',    
              method: 'POST',
              params: {'data':Ext.util.JSON.encode(e.record.data),'method':'save'},
              success: function() {
                  e.record.commit(); 
                  myMask.hide();
                //post-processing here - this might include reloading the grid if there are calculated fields
              }
            });    
    };
    
   //Grid heigth
   Ext.EventManager.onWindowResize(resizeGrid); 
   
   function resizeGrid(){
    sizes=Ext.getBody().getViewSize();   
    gridStudio.setHeight(sizes.height);
   }
   

});

